//+------------------------------------------------------------------+
//|                                                 MP DailyStat.mq4 |
//|                                                          Rafaell |
//|                                                          http:// |
//+------------------------------------------------------------------+


#property copyright "Rafaell"
#property link      "http://"

//#property indicator_chart_window
#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color3 Khaki
#property indicator_color4 Khaki
#property indicator_color1 C'40,43,43'
#property indicator_color2 C'40,43,43'

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 5

#property indicator_level1 0
#property indicator_levelstyle STYLE_DASHDOTDOT
#property indicator_levelcolor1 DarkSlateGray

#import "MPDailyStat.dll"
int SymCount(string  ,int);
string SymSett(string,string& arr[] , int, int);
#import


extern string  ISymbols = "EURUSD,GBPUSD,USDCHF,USDCAD,AUDUSD,NZDUSD,GBPCHF,GBPJPY,EURCHF";


extern bool    showDailyStat= True;

extern bool    changeInPips = True;   
extern int     statMode=1;
extern int     timeAdj=0;
extern int     sideDS = 3;
extern int     barsSpace = 0;

extern bool    showMTStat = True;
extern bool    showSmallTfText = False;
extern string  Tperiod1 = "2000.1.1";
extern string  Tperiod2 = "2005.1.1";
extern string  Tperiod3 = "2007.1.1";
extern string  Tperiod4 = "2008.1.1";
extern string  Tperiod5 = "2009.1.1";
extern string  Tperiod6 = "2009.3.1 00:00";
extern int     fontSize=10;
extern string  fontName = "";


//extern string Tperiod5 = "D3";



int tfc[]={PERIOD_D1, PERIOD_H4, PERIOD_H1, PERIOD_M30, PERIOD_M15, PERIOD_M5};
string tfsc[] = {"D", "H4", "H1", "M30", "M15", "M5"};
string tfs[12];
int tf[12];
int tfFBar[][12];
datetime tfstart[][12];
int numTf = 12; 
int i,j,k,n,m;
int numSym;
int multb;
int space;
int lastBar;


int dataPeriod = PERIOD_H1;
int lDataBar=1;

bool checkForData=False;
double   current[],
         pcurrent[],
         dh[],
         dl[],
         dch[],
         dcl[],
         dco[],
         dr[],
         dmco[][12],
         dHigh[],
         dLow[];
int   pBars[][12];
bool  avalDataTf[][12];
double toPoint[];
string ssym[];
string ssymShow[];
string ind;
int smTF;
int   xx=5,
      xx0;
int yy=5;
int whereDS=0;
int numPrObj;
int firstTf = 6;
//datetime pTime[];

//bool recaldata[];




color textCol=YellowGreen;
color dCol = Red;
color uCol = LightGreen;   
color nCol = Gold;

double mr[];
double mr1[];
double hi[];
double lo[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexBuffer(2, mr);
   SetIndexStyle(2 ,DRAW_HISTOGRAM);
   SetIndexBuffer(3, mr1);
   SetIndexStyle(3 ,DRAW_HISTOGRAM);
   SetIndexBuffer(0, hi);
   SetIndexStyle(0 ,DRAW_HISTOGRAM);
   SetIndexBuffer(1, lo);
   SetIndexStyle(1 ,DRAW_HISTOGRAM);
   
   numSym = SymCount(ISymbols,StringLen(ISymbols));
   if (numSym > 10)
      numSym = 10;
   ArrayResize(ssym, numSym);
   
   
   
   n=0;
   for (i=0; i<numSym; i++) {
      ssym[i-n] = SymSett(ISymbols, ssym, numSym,i);
      if (iOpen(ssym[i-n],dataPeriod,1) == 0) {          
         checkForData = CheckForData(ssym[i-n], dataPeriod, 1);
         if (checkForData == False) {
            Alert("Please check currency symbol inputs. No spaces, ...just symbols and ',' \n If your inputs are OK, maybe need some time to update data!!  ", ssym[i]);
            n++;           
         }
      }  
   }
   numSym -= n;
   if (numSym <= 0) {
      Alert("All symols inputs are wrong");   
      return (-1);
   }    
//   numSym -= n;
   ArrayResize(ssymShow, numSym);
   
   for (i=0; i<numSym; i++) {
      ssymShow[i] = StringSubstr(ssym[i], 0, 2);
      ssymShow[i] = StringConcatenate(ssymShow[i], "/", StringSubstr(ssym[i], 3, 2));
   }
   
   ArrayResize(current, numSym);
   ArrayResize(pcurrent, numSym);
   ArrayResize(dh, numSym);
   ArrayResize(dl, numSym);
   ArrayResize(dch, numSym);
   ArrayResize(dcl, numSym);
   ArrayResize(dco, numSym);
   ArrayResize(dr, numSym);
   ArrayResize(toPoint, numSym);      
   ArrayResize(dmco, numSym);
   ArrayResize(dHigh, numSym);
   ArrayResize(dLow, numSym);

   
//   ArrayResize(recaldata, numSym);
   ArrayResize(avalDataTf, numSym);
   ArrayInitialize(avalDataTf, False); 
   
   ind = WindowExpertName();
   IndicatorShortName(ind); 
   
   for (i=0; i<numSym; i++) {
      if (MarketInfo(ssym[0], MODE_DIGITS) == 3 || MarketInfo(ssym[0], MODE_DIGITS) == 5)
         toPoint[i]=MarketInfo(ssym[i], MODE_POINT) * 10;
      else
         toPoint[i]=MarketInfo(ssym[i], MODE_POINT);
   }
   
   tfs[6] = Tperiod1;
   tfs[7] = Tperiod2;
   tfs[8] = Tperiod3;
   tfs[9] = Tperiod4;
   tfs[10] = Tperiod5;
   tfs[11] = Tperiod6;
   
   
   if (StringLen(tfs[6]) < 2) {
      Alert("Please check inserted time period.. Tperiod1..");
      return(0);
   }
   for (i=7; i<numTf; i++) {
      if (StringLen(tfs[i]) < 2) {
         Alert("Please check inserted time period.. Tperiod",i-5,"..");
//         numTf--;
      }
 /*     else if (StringLen(tfs[i-1]) < 2 && StringLen(tfs[i]) > 2)
            tfs[i-1] = tfs[i];   
*/   }   
   
   
   ArrayResize(tfFBar, numSym);
   ArrayResize(tfstart, numSym);
   ArrayResize(pBars, numSym);
   ArrayInitialize(pBars, 1);
   
   for (i=0; i<6; i++) {
      if (tfc[i] == 0) {
         tf[i] = -1;
         tfs[i] = " ";
      }
      else {   
         tf[i]=PERIOD_M1; 
         tfs[i] = tfsc[i];
      }
      
      
      for (j=0; j<numSym;j++) {
         if (tfc[i] == 0) {
            tfstart[j][i] = -1;
            tfFBar[j][i]=-2;
         }   
         else {
            tfstart[j][i] = TimeCurrent() - (tfc[i]-1)*60;     
            tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False);
        }
         avalDataTf[j][i] = CheckForData(ssym[j], tf[i], tfFBar[j][i]+1);   
      }
   }
  
          
   
   
   for (i=6; i<numTf; i++) {
      tf[i]=PERIOD_D1;                   // make function!!!
      n = StringGetChar(tfs[i],0);
      if (n > 47 && n < 58) {
         for(j=0; j<numSym; j++) {
            tfstart[j][i] =  StrToTime(tfs[i]);
            tfFBar[j][i] = iBarShift(ssym[j], tf[i], tfstart[j][i], False); 
            checkForData = CheckForData(ssym[0], tf[i], tfFBar[j][i]+1);
            avalDataTf[j][i] = checkForData;
            if ( tfstart[j][i] - iTime(ssym[j], tf[i], tfFBar[j][i]+1) > 5*60*24*60+tf[i]*60) {
               checkForData = CheckForData(ssym[0], tf[i], tfFBar[j][i]+1);
               avalDataTf[j][i] = checkForData;
               if (checkForData == False) {
 //                 tfFBar[j][i] = iBars(ssym[j], tf[i])-1;
                  Alert ("Can not find data for: ",ssym[j],"  ", tfs[i],"First aval.", TimeToStr(iTime(ssym[j], tf[i], iBars(ssym[j], tf[i])-2),TIME_DATE));
               }
            }
            else {
               pBars[j][i] = iBars(ssym[j], tf[i]);
               avalDataTf[j][i] = True;
            } 
         }
      }
/*      else if (n > 61 && n < 91) {
         switch (n) {
            case 'M': {
               if (StringGetChar(tfs[i],1) == 'N')
                  tf[i] = ToInt(tfs[i], 2);
            } break;
            //
            //Not in use yet
            //
            //
         }
      }
*/   }

     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for (i=0; i<=(numSym+1)*(6); i++)
      ObjectDelete(ind+(i)); 
   
   ObjectsDeleteAll(WindowFind(ind));     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//   int    counted_bars=IndicatorCounted();
//----
   
      
    
   
         
//   recaldata[i] = False; 
   
   
   lDataBar = iBarShift(ssym[0], dataPeriod, StartBar(0, 0, 0, 1, statMode, timeAdj), False);
   
   if (showDailyStat == True || showMTStat == True) {
      for (i=0; i<numSym; i++) {
         current[i] = iClose(ssym[i], tf[0], 0);
         if (current[i] == 0) {
            dh[i]=0;
            dl[i]=0;
            dch[i]=0;
            dcl[i]=0;
            dco[i]=0;
         }
         else if ((current[i] != pcurrent[i]) /* || iTime(ssym[i], dataPeriod,0)  != pTime[i]*/) { 
            //recaldata[i] = True;
            dh[i] = iHigh(ssym[i], dataPeriod, iHighest(ssym[i],dataPeriod,MODE_HIGH, lDataBar,0));
            dl[i] = iLow(ssym[i], dataPeriod, iLowest(ssym[i],dataPeriod,MODE_LOW, lDataBar,0));
            dch[i] = (dh[i]-current[i])/toPoint[i];
            dcl[i] = (current[i]-dl[i])/toPoint[i];
            dr[i] = (dh[i]-dl[i])/toPoint[i];
            if (changeInPips == True)
               dco[i] = (current[i]- iClose(ssym[i],dataPeriod,lDataBar+1))/toPoint[i];
            else
               dco[i] = (current[i]- iClose(ssym[i],dataPeriod,lDataBar+1))*100/iClose(ssym[i],dataPeriod,lDataBar+1);
         }
      }
   }      

//---- no needed      
   if (current[0] == pcurrent[0])
         return(0);  
   pcurrent[0] = current[0];
   
   for (i=0; i<numSym; i++) 
      for (j=0; j<6; j++) 
         tfstart[i][j] = TimeCurrent() - (tfc[j]-1)*60;  
      
   for (i=0; i<numSym; i++) {
      for (j=0; j<numTf; j++) {
         if (iBars(ssym[i], tf[j]) > pBars[i][j]) {
            pBars[i][j] = iBars(ssym[i], tf[j]);
            tfFBar[i][j] = iBarShift(ssym[i], tf[j], tfstart[i][j], False);
            checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
            avalDataTf[i][j] = checkForData;     
         }
      }
      dHigh[i] = (current[i]-iHigh(ssym[i], tf[0], iHighest(ssym[i],tf[0],MODE_HIGH, tfFBar[i][0]+1,0)))/toPoint[i];
      dLow[i] = (current[i]-iLow(ssym[i], tf[0], iLowest(ssym[i],tf[0],MODE_LOW, tfFBar[i][0]+1,0)))/toPoint[i];
      
   }
   
   
   
   
   
   n=0;
   if (showDailyStat == True) {
 //     whereDS = 0;
      n=6;
      xx0=190;

         WriteL(ind+0, sideDS, xx+165, yy, StringConcatenate("From: ",TimeToStr(iTime(NULL, dataPeriod, lDataBar+1)+60*dataPeriod,TIME_DATE|TIME_MINUTES)), fontSize-3,fontName ,textCol,whereDS);   
         WriteL(ind+1, sideDS, xx+140, yy," Bid     ", fontSize-3,fontName ,textCol,whereDS);
         WriteL(ind+2, sideDS, xx+105, yy," Daily range ", fontSize-3,fontName ,textCol,whereDS); 
         WriteL(ind+3, sideDS, xx+70, yy," From high ", fontSize-3,fontName ,textCol,whereDS);
         WriteL(ind+4, sideDS, xx+40, yy," From low ", fontSize-3,fontName ,textCol,whereDS);
         WriteL(ind+5, sideDS, xx, yy," Change ", fontSize-3,fontName ,textCol,whereDS);
      
      for (i=0; i<numSym; i++) {
 //        if (recaldata[i] == True) {
            color cCol = SetCol(dco[i]);
            WriteL(ind+(i+n), sideDS, xx+190, yy+10*(i+1), ssymShow[i], fontSize,NULL ,cCol,whereDS); 
            WriteL(ind+(i+n+1*numSym), sideDS, xx+140, yy+10*(i+1), DoubleToStr(current[i], MarketInfo(ssym[i], MODE_DIGITS)), fontSize,fontName ,cCol,whereDS); 
            WriteL(ind+(i+n+2*numSym), sideDS, xx+105, yy+10*(i+1), DoubleToStr(dr[i], 0), fontSize,fontName ,cCol,whereDS);
            WriteL(ind+(i+n+3*numSym), sideDS, xx+70, yy+10*(i+1), DoubleToStr(dch[i], 0), fontSize,fontName ,cCol,whereDS); 
            WriteL(ind+(i+n+4*numSym), sideDS, xx+40, yy+10*(i+1), DoubleToStr(dcl[i], 0), fontSize,fontName ,cCol,whereDS); 
            if (changeInPips == True)
               WriteL(ind+(i+n+5*numSym), sideDS, xx, yy+10*(i+1), DoubleToStr(dco[i], 0), fontSize,fontName ,cCol,whereDS); 
            else
               WriteL(ind+(i+n+5*numSym), sideDS, xx, yy+10*(i+1), StringConcatenate(DoubleToStr(dco[i], 2),"%"), fontSize,fontName ,cCol,whereDS);
//         }
      }
   } 
      
 
   if (showMTStat == True) {
      numPrObj = n*(numSym+1);
      n++;
      xx0=xx;
      
      for (i=0; i<numSym; i++) 
         WriteL(ind+(i+numPrObj), 1, xx+i*35, yy, ssymShow[i], fontSize-1,NULL , textCol,WindowFind(ind));
   
      numPrObj = n*(numSym+1);
      xx0 += numSym*35;
      
      if (showSmallTfText ==True) {
         firstTf=0;
         for (i=firstTf; i<6; i++) 
            WriteL(ind+(i+numPrObj), 1, xx0, yy+10*(i-firstTf+1), StringConcatenate(tfs[i]," (",TimeToStr(iTime(ssym[0], tf[i],tfFBar[0][i]+1)+tf[i]*60, TIME_MINUTES), ")"), fontSize-2,NULL ,textCol,WindowFind(ind));
      }
      else
         firstTf=6;
      
      for (i=6; i<numTf; i++) 
         WriteL(ind+(i+numPrObj), 1, xx0, yy+10*(i-firstTf+1), tfs[i], fontSize-2,NULL ,textCol,WindowFind(ind));
       
      numPrObj += (numTf-firstTf);
      for (i=0; i<numSym; i++) {
//         if (recaldata[i] == True) {
            for (j=0; j<numTf; j++) {
               if (avalDataTf[i][j]==true)
                  dmco[i][j]= (current[i]- iClose(ssym[i],tf[j],tfFBar[i][j]+1))/toPoint[i];
                 
               else {
                  checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
                  avalDataTf[i][j]=checkForData;     
                  dmco[i][j]=0;
               }               
            }
//         }         
      }
      
      
      
      for (i=0; i<numSym; i++) {
         for (j=firstTf; j<numTf; j++) {
            if (avalDataTf[i][j] == True)
               WriteL(ind+(i+(j)*numSym+numPrObj), 1, xx+i*35, yy+10*(j-firstTf+1),  DoubleToStr(dmco[i][j], 0), fontSize,fontName ,SetCol(dmco[i][j]),WindowFind(ind));     
         }
      }
   }
   
   else {
      for (i=0; i<numSym; i++) {
         for (j=0; j<6; j++) {
            if (avalDataTf[i][j]==true)
               dmco[i][j]= (current[i]- iClose(ssym[i],tf[j],tfFBar[i][j]+1))/toPoint[i];
            else {
               checkForData = CheckForData(ssym[i], tf[j], tfFBar[i][j]+1);
               avalDataTf[i][j]=checkForData;     
               dmco[i][j]=0;               
            }         
         }
      }
   }
      
   ArrayInitialize(mr, EMPTY_VALUE);
   ArrayInitialize(mr1, EMPTY_VALUE);
   ArrayInitialize(hi, EMPTY_VALUE);
   ArrayInitialize(lo, EMPTY_VALUE);
   
//   int ce = WindowFirstVisibleBar();
   int ce = WindowBarsPerChart();
   
   
   if(barsSpace < ce -  WindowFirstVisibleBar())
      barsSpace = ce -  WindowFirstVisibleBar();
   ce -= (barsSpace);
   
   multb=MathFloor(ce/(numSym*6+numSym-1));
   space = MathFloor((ce - multb*numSym*6)/(numSym-1));
    
   
   lastBar = WindowFirstVisibleBar()-numSym*(multb*6 + (space-1));  
   if (lastBar < 0)
      lastBar = 0;
   
   
   for (i=0; i<numSym; i++)
      for (j=0; j<6; j+=2)
         for(k=0; k<multb; k++) {
           // mr[ce-multb*j-k-i*(space+multb*numTf)] = dmco[numSym-i-1][numTf-7-j];
           mr[lastBar + k + multb*j + i*(space+multb*6)] = dmco[i][numTf-7-j];
           hi[lastBar + k + multb*j + i*(space+multb*6)] = dHigh[i];
           lo[lastBar + k + multb*j + i*(space+multb*6)] = dLow[i];
   }
   
   for (i=0; i<numSym; i++) {
      for (j=1; j<6; j+=2) 
         for(k=0; k<multb; k++) {
            mr1[lastBar + k + multb*j + i*(space+multb*6)] = dmco[i][numTf-7-j];
            hi[lastBar + k + multb*j + i*(space+multb*6)] = dHigh[i];
            lo[lastBar + k + multb*j + i*(space+multb*6)] = dLow[i];
      }
      WriteT(ind+(ssymShow[i]+i), 1, Time[lastBar + k + multb*j + i*(space+multb*6)-multb*4], WindowPriceMin(WindowFind(ind))+0.3*(WindowPriceMax(WindowFind(ind))-WindowPriceMin(WindowFind(ind))) , ssymShow[i], fontSize+5,NULL ,textCol,WindowFind(ind));  
   }         
    WindowRedraw();         
 /*         
   for (i=0; i<numTf; i++) {
      mr[ce-2*i-5] = dmco[0][numTf-i];
      mr[ce-2*i-6] = dmco[0][numTf-i];
   }
     
   for (i=0; i<numSym; i++) {
      pcurrent[i] = current[i];
         
   }
  */  
//   for (i=0; i<numSym; i++)
//      pTime[i] = iTime(ssym[i], tf[i],0);
//----
   return(0);
  }

//+------------------------------------------------------------------+




void WriteL(string LBL, double side, int X, int Y, string text, int fontsize, string fontname, color lcolor, int where)
{

//   if (ObjectFind(LBL) < 0) {
      ObjectCreate(LBL, OBJ_LABEL, where, 0 , 0);
      ObjectSet(LBL, OBJPROP_CORNER, side); 
      ObjectSet(LBL, OBJPROP_XDISTANCE, X);
      ObjectSet(LBL, OBJPROP_YDISTANCE, Y);
      
//   }
   ObjectSetText(LBL,text, fontsize, fontname, lcolor);
 
}

void WriteT(string LBL, double side, datetime X, double Y, string text, int fontsize, string fontname, color lcolor, int where)
{

   if (ObjectFind(LBL) < 0) {
      ObjectCreate(LBL, OBJ_TEXT, where, X , Y);
      ObjectSetText(LBL,text, fontsize, fontname, lcolor);
   }
   else {
      ObjectMove(LBL, 0, X, Y); 
   }

 
}


//+------------------------------------------------------------------+
/*
void TBar(string LBL, int X,  double h, int X1, color Tcol)
{

   ObjectCreate(LBL, OBJ_RECTANGLE, WindowFind(ind), 0 , 0);
   ObjectSet(LBL, OBJPROP_COLOR, Tcol);
   ObjectCreate(LBL+"1", OBJ_TEXT, WindowFind(ind), (X+X1)/2 , 0.9*h);
   ObjectSet(LBL+"1", OBJPROP_CORNER, 0);
   ObjectSetText(LBL+"1",text, fontsize, fontname, T1color);
//   ObjectSet(LBL+"1", OBJPROP_ANGLE, 90);
 
 
} 
*/ 

//+------------------------------------------------------------------+






datetime StartBar(int dye, int dmo, int dwe, int dda, int typ, int ot)
{
   int ye,mo,da,ho;
   datetime ct;
     
      
   ct=TimeCurrent();
   switch (typ) {
      case 0: {
         ct -= 60*60*(24)*(dda-1);
         ct -= 60*60*24*(7)*(dwe);
         
         ye = TimeYear(ct);
         mo = TimeMonth(ct);
         da = TimeDay(ct);
         ho = TimeHour(ct);

         if (dda > 0)
            ho=0;
         if (dwe > 0) {
            da -= (TimeDayOfWeek(TimeCurrent())-1);
            ho=0;
            //da -= DayOfWeek();      
         }
         if (dmo > 0) {
           da=1;
           ho=0;
           mo -= (dmo-1);
           while (mo < 0) {
               mo +=12;
               ye -= 1;
            }
         }
         if (dye > 0) {
           da=1;
           mo=1;
           // da  -= DayOfYear()+1 ;
           ho=0;
           ye -= (dye-1);
         
         }
       if (ot != 0) {
           ct = StrToTime(da+"."+mo+"."+ye+" "+ho);
           if (ot > TimeHour(TimeCurrent()))
               ct = ct + (ot-24)*3600;     
           else 
             ct += (ot)*3600;    
           //cd -=  (ot)*3600
           ye = TimeYear(ct);
           mo = TimeMonth(ct);
           da = TimeDay(ct);
           ho = TimeHour(ct);
        }
        
      } break;
      
      case 1: {      
         ct = TimeCurrent()+3600;
         if (dda > 0) 
            ct -= 60*60*(24)*dda;
         if (dwe > 0)
            ct -= 60*60*24*(7)*dwe;   
      
         ye = TimeYear(ct);
         mo = TimeMonth(ct);
         da = TimeDay(ct);
         ho = TimeHour(ct);
      
         if (dmo > 0) {
            mo -= dmo;
            while (mo < 0) {
               mo +=12;
               ye -= 1;
            }
         }
         if (dye > 0) {
            ye -= dye;
         }
     } break;
     
     default: {
         ye = Year();
          mo = Month();
          da = Day();
         ho = Hour();   
     } break;
  }   
 // return (StrToTime(StringConcatenate(/*"D'",*/da,".",mo,".",ye," ",ho/*,"'"*/)));
  return (StrToTime(da+"."+mo+"."+ye+" "+ho));   
} 

//+------------------------------------------------------------------+

color SetCol(double param)
{
   if (param > 0)
      return(uCol);
   else if (param < 0)
      return(dCol);
   else
      return(nCol);
}
      

//+------------------------------------------------------------------+

bool CheckForData(string sym, int per, int n)
{
   
   if (iOpen(sym,per,n) == 0) {
      for (int j=0; j<10; j++) {
         RefreshRates();
         if (iOpen(sym,per,n) > 0) 
            return (True);
         Sleep(500);   
      }
      RefreshRates();               
      if (iOpen(sym, per, n) > 0) 
          return (True);
      else {
        // Alert("Please check currency symbol inputs. No spaces, ...just symbols and ',' \n If your inputs are OK, maybe need some time to update data!!  ", ssym[i]);
         return (False);
      }
   }
   return (True);
}

//+------------------------------------------------------------------+ 


int ToInt(string convert, int start)
{
   string conv;
   
   conv = StringSubstr(convert, start, StringLen(convert)-start);
   return(StrToInteger(conv));
}
   
    